{
    "$graph": [
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "bash",
                "run.add_header.sh"
            ],
            "stdout": "output.txt",
            "requirements": [
                {
                    "listing": [
                        {
                            "entryname": "run.add_header.sh",
                            "entry": "echo \"$1\"\ncat \"$2\""
                        }
                    ],
                    "class": "InitialWorkDirRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#add_header.cwl/header_str"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#add_header.cwl/input_file"
                }
            ],
            "id": "#add_header.cwl",
            "hints": [
                {
                    "class": "LoadListingRequirement",
                    "loadListing": "deep_listing"
                },
                {
                    "class": "NetworkAccess",
                    "networkAccess": true
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#add_header.cwl/output_file",
                    "outputBinding": {
                        "glob": "output.txt"
                    }
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "calc-tmb.py",
                "from-file"
            ],
            "requirements": [
                {
                    "dockerPull": "mskcc/helix_filters_01:21.4.1",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--genome-coverage",
                        "position": 3
                    },
                    "id": "#calc-tmb.cwl/genome_coverage"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#calc-tmb.cwl/input_file"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--normal-id",
                        "position": 4
                    },
                    "id": "#calc-tmb.cwl/normal_id"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#calc-tmb.cwl/output_filename"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_filename)"
                    },
                    "id": "#calc-tmb.cwl/output_file"
                }
            ],
            "id": "#calc-tmb.cwl",
            "hints": [
                {
                    "class": "LoadListingRequirement",
                    "loadListing": "deep_listing"
                },
                {
                    "class": "NetworkAccess",
                    "networkAccess": true
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "maf_filter.py"
            ],
            "requirements": [
                {
                    "dockerPull": "mskcc/helix_filters_01:21.4.1",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "analysis.muts.maf",
                    "inputBinding": {
                        "prefix": "--analyst-file",
                        "position": 4
                    },
                    "id": "#maf_filter.cwl/analysis_mutations_filename"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--version-string",
                        "position": 2
                    },
                    "id": "#maf_filter.cwl/argos_version_string"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "data_mutations_extended.txt",
                    "inputBinding": {
                        "prefix": "--portal-file",
                        "position": 5
                    },
                    "id": "#maf_filter.cwl/cbio_mutation_data_filename"
                },
                {
                    "type": "boolean",
                    "inputBinding": {
                        "prefix": "--is-impact",
                        "position": 3
                    },
                    "id": "#maf_filter.cwl/is_impact"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "prefix": "--keep-rejects",
                        "position": 7
                    },
                    "id": "#maf_filter.cwl/keep_rejects"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#maf_filter.cwl/maf_file"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "rejected.muts.maf",
                    "inputBinding": {
                        "prefix": "--rejected-file",
                        "position": 6
                    },
                    "id": "#maf_filter.cwl/rejected_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.analysis_mutations_filename)"
                    },
                    "id": "#maf_filter.cwl/analysis_mutations_file"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.cbio_mutation_data_filename)"
                    },
                    "id": "#maf_filter.cwl/cbio_mutation_data_file"
                },
                {
                    "$import": "#maf_filter.cwl/rejected_file"
                }
            ],
            "id": "#maf_filter.cwl",
            "hints": [
                {
                    "class": "LoadListingRequirement",
                    "loadListing": "deep_listing"
                },
                {
                    "class": "NetworkAccess",
                    "networkAccess": true
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "paste-col.py"
            ],
            "requirements": [
                {
                    "dockerPull": "mskcc/helix_filters_01:21.4.1",
                    "class": "DockerRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--header",
                        "position": 3
                    },
                    "id": "#paste-col.cwl/header"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-i",
                        "position": 1
                    },
                    "id": "#paste-col.cwl/input_file"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "-o",
                        "position": 2
                    },
                    "id": "#paste-col.cwl/output_filename"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "--value",
                        "position": 4
                    },
                    "id": "#paste-col.cwl/value"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_filename)"
                    },
                    "id": "#paste-col.cwl/output_file"
                }
            ],
            "id": "#paste-col.cwl",
            "hints": [
                {
                    "class": "LoadListingRequirement",
                    "loadListing": "deep_listing"
                },
                {
                    "class": "NetworkAccess",
                    "networkAccess": true
                }
            ]
        },
        {
            "class": "Workflow",
            "doc": " Workflow to run the TMB analysis on a batch of samples and merge the results back into a single data clinical file ",
            "requirements": [
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "name": "#types.yml/FilloutMafOptionalSample",
                            "doc": "A tumor sample record for variant fillout that might lack a .maf file but HAS a .bam file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#types.yml/FilloutMafOptionalSample/sample_id",
                                    "type": "string",
                                    "doc": "sample identifier must match the ID used inside the maf file"
                                },
                                {
                                    "name": "#types.yml/FilloutMafOptionalSample/normal_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/FilloutMafOptionalSample/sample_type",
                                    "type": "string",
                                    "doc": "should be one of \"research\" or \"clinical\""
                                },
                                {
                                    "name": "#types.yml/FilloutMafOptionalSample/maf_file",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "an optional input .maf file"
                                },
                                {
                                    "name": "#types.yml/FilloutMafOptionalSample/bam_file",
                                    "doc": "sample's alignment file",
                                    "type": "File",
                                    "secondaryFiles": [
                                        {
                                            "pattern": ".bai",
                                            "required": null
                                        }
                                    ]
                                }
                            ]
                        },
                        {
                            "name": "#types.yml/FilloutNoMafsample",
                            "doc": "A tumor sample record for variant fillout does NOT have a .maf file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#types.yml/FilloutNoMafsample/sample_id",
                                    "type": "string",
                                    "doc": "sample identifier must match the ID used inside the maf file"
                                },
                                {
                                    "name": "#types.yml/FilloutNoMafsample/normal_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/FilloutNoMafsample/sample_type",
                                    "type": "string",
                                    "doc": "should be one of \"research\" or \"clinical\""
                                },
                                {
                                    "name": "#types.yml/FilloutNoMafsample/bam_file",
                                    "doc": "sample's alignment file",
                                    "type": "File",
                                    "secondaryFiles": [
                                        {
                                            "pattern": ".bai",
                                            "required": null
                                        }
                                    ]
                                },
                                {
                                    "name": "#types.yml/FilloutNoMafsample/unfiltered_vcf",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "fillout vcf file produced for the sample with no filtering applied"
                                },
                                {
                                    "name": "#types.yml/FilloutNoMafsample/filtered_vcf",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "fillout vcf that has had extra filters applied such as germline filtering"
                                },
                                {
                                    "name": "#types.yml/FilloutNoMafsample/unfiltered_maf",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "fillout maf file produced for the sample"
                                },
                                {
                                    "name": "#types.yml/FilloutNoMafsample/filtered_maf",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "fillout maf that has had extra filters applied such as germline filtering"
                                }
                            ]
                        },
                        {
                            "name": "#types.yml/FilloutSample",
                            "doc": "A tumor sample record to be used for variant fillout which MUST have a .maf file and indexed .bam file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#types.yml/FilloutSample/sample_id",
                                    "type": "string",
                                    "doc": "sample identifier must match the ID used inside the maf file"
                                },
                                {
                                    "name": "#types.yml/FilloutSample/normal_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/FilloutSample/sample_type",
                                    "type": "string",
                                    "doc": "should be one of \"research\" or \"clinical\""
                                },
                                {
                                    "name": "#types.yml/FilloutSample/maf_file",
                                    "type": "File",
                                    "doc": "the sample's input .maf file"
                                },
                                {
                                    "name": "#types.yml/FilloutSample/bam_file",
                                    "doc": "sample's alignment file",
                                    "type": "File",
                                    "secondaryFiles": [
                                        {
                                            "pattern": ".bai",
                                            "required": null
                                        }
                                    ]
                                },
                                {
                                    "name": "#types.yml/FilloutSample/unfiltered_vcf",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "fillout vcf file produced for the sample with no filtering applied"
                                },
                                {
                                    "name": "#types.yml/FilloutSample/filtered_vcf",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "fillout vcf that has had extra filters applied such as germline filtering"
                                },
                                {
                                    "name": "#types.yml/FilloutSample/unfiltered_maf",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "fillout maf file produced for the sample"
                                },
                                {
                                    "name": "#types.yml/FilloutSample/filtered_maf",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "fillout maf that has had extra filters applied such as germline filtering"
                                }
                            ]
                        },
                        {
                            "name": "#types.yml/FilloutIndexSample",
                            "doc": "A FilloutSample needs .bam indexing and prefiltering applied",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#types.yml/FilloutIndexSample/sample_id",
                                    "type": "string",
                                    "doc": "sample identifier must match the ID used inside the maf file"
                                },
                                {
                                    "name": "#types.yml/FilloutIndexSample/normal_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/FilloutIndexSample/sample_type",
                                    "type": "string",
                                    "doc": "should be one of \"research\" or \"clinical\""
                                },
                                {
                                    "name": "#types.yml/FilloutIndexSample/prefilter",
                                    "type": "boolean",
                                    "doc": "if the sample maf file needs to be pre-filtered (true) or not (false)"
                                },
                                {
                                    "name": "#types.yml/FilloutIndexSample/maf_file",
                                    "type": "File",
                                    "doc": "the sample's input .maf file"
                                },
                                {
                                    "name": "#types.yml/FilloutIndexSample/bam_file",
                                    "type": "File",
                                    "doc": "bam file that needs a .bai file generated"
                                }
                            ]
                        },
                        {
                            "name": "#types.yml/FilloutMafOptionalNoIndexSample",
                            "doc": "A tumor sample record for variant fillout that might lack a .maf file but HAS a .bam file without a .bai index file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#types.yml/FilloutMafOptionalNoIndexSample/sample_id",
                                    "type": "string",
                                    "doc": "sample identifier must match the ID used inside the maf file"
                                },
                                {
                                    "name": "#types.yml/FilloutMafOptionalNoIndexSample/normal_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/FilloutMafOptionalNoIndexSample/sample_type",
                                    "type": "string",
                                    "doc": "should be one of \"research\" or \"clinical\""
                                },
                                {
                                    "name": "#types.yml/FilloutMafOptionalNoIndexSample/maf_file",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "an optional input .maf file"
                                },
                                {
                                    "name": "#types.yml/FilloutMafOptionalNoIndexSample/bam_file",
                                    "doc": "sample's alignment file",
                                    "type": "File"
                                }
                            ]
                        },
                        {
                            "name": "#types.yml/FilloutMafOptionalIndexedSample",
                            "doc": "A tumor sample record for variant fillout that might lack a .maf file but HAS a .bam file and a .bai index file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#types.yml/FilloutMafOptionalIndexedSample/sample_id",
                                    "type": "string",
                                    "doc": "sample identifier must match the ID used inside the maf file"
                                },
                                {
                                    "name": "#types.yml/FilloutMafOptionalIndexedSample/normal_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/FilloutMafOptionalIndexedSample/sample_type",
                                    "type": "string",
                                    "doc": "should be one of \"research\" or \"clinical\""
                                },
                                {
                                    "name": "#types.yml/FilloutMafOptionalIndexedSample/maf_file",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "an optional input .maf file"
                                },
                                {
                                    "name": "#types.yml/FilloutMafOptionalIndexedSample/bam_file",
                                    "doc": "sample's alignment file",
                                    "type": "File",
                                    "secondaryFiles": [
                                        {
                                            "pattern": ".bai",
                                            "required": null
                                        }
                                    ]
                                }
                            ]
                        },
                        {
                            "name": "#types.yml/FilloutIndexedSample",
                            "doc": "A fillout sample that HAS a pre-filtered .maf file and HAS an indexed .bam file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#types.yml/FilloutIndexedSample/sample_id",
                                    "type": "string",
                                    "doc": "sample identifier must match the ID used inside the maf file"
                                },
                                {
                                    "name": "#types.yml/FilloutIndexedSample/normal_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/FilloutIndexedSample/sample_type",
                                    "type": "string",
                                    "doc": "should be one of \"research\" or \"clinical\""
                                },
                                {
                                    "name": "#types.yml/FilloutIndexedSample/prefilter",
                                    "type": "boolean",
                                    "doc": "if the sample maf file needs to be pre-filtered (true) or not (false)"
                                },
                                {
                                    "name": "#types.yml/FilloutIndexedSample/maf_file",
                                    "type": "File",
                                    "doc": "the sample's input .maf file"
                                },
                                {
                                    "name": "#types.yml/FilloutIndexedSample/bam_file",
                                    "type": "File",
                                    "doc": "bam file that needs a .bai file generated",
                                    "secondaryFiles": [
                                        {
                                            "pattern": ".bai",
                                            "required": null
                                        }
                                    ]
                                }
                            ]
                        },
                        {
                            "name": "#types.yml/TNMafPileupPair",
                            "doc": "a tumor normal sample pair with .maf and snp pileup files",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#types.yml/TNMafPileupPair/tumor_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/TNMafPileupPair/normal_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/TNMafPileupPair/pair_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/TNMafPileupPair/snp_pileup",
                                    "type": "File"
                                },
                                {
                                    "name": "#types.yml/TNMafPileupPair/pair_maf",
                                    "type": "File"
                                }
                            ]
                        },
                        {
                            "name": "#types.yml/TMBInputPair",
                            "doc": "a tumor normal pair for input to Tumor Mutation Burden analysis",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#types.yml/TMBInputPair/tumor_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/TMBInputPair/normal_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/TMBInputPair/pair_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/TMBInputPair/pair_maf",
                                    "type": "File"
                                }
                            ]
                        },
                        {
                            "name": "#types.yml/TMBOutputPair",
                            "doc": "a tumor normal pair for input to Tumor Mutation Burden analysis",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#types.yml/TMBOutputPair/tumor_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/TMBOutputPair/normal_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/TMBOutputPair/pair_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/TMBOutputPair/tmb_maf",
                                    "type": "File",
                                    "doc": "filtered mutations used for TMB calculation"
                                },
                                {
                                    "name": "#types.yml/TMBOutputPair/tmb_tsv",
                                    "type": "File",
                                    "doc": "table with TMB values for the sample pair"
                                }
                            ]
                        },
                        {
                            "name": "#types.yml/MSIInputPair",
                            "doc": "a tumor normal sample pair to be used for microsatellite instability analysis",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#types.yml/MSIInputPair/tumor_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/MSIInputPair/normal_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/MSIInputPair/pair_id",
                                    "type": "string"
                                }
                            ]
                        },
                        {
                            "name": "#types.yml/MSIOutputPair",
                            "doc": "a tumor normal sample pair that has undergone microsatellite instability analysis",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#types.yml/MSIOutputPair/tumor_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/MSIOutputPair/normal_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/MSIOutputPair/pair_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/MSIOutputPair/msi_tsv",
                                    "doc": "parsed output from msisensor",
                                    "type": "File"
                                }
                            ]
                        },
                        {
                            "name": "#types.yml/FacetsPair",
                            "doc": "a tumor normal sample pair used in Facets",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#types.yml/FacetsPair/tumor_id",
                                    "type": "string",
                                    "doc": "..."
                                },
                                {
                                    "name": "#types.yml/FacetsPair/normal_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/FacetsPair/pair_id",
                                    "type": "string"
                                },
                                {
                                    "name": "#types.yml/FacetsPair/purity_png",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "..."
                                },
                                {
                                    "name": "#types.yml/FacetsPair/purity_seg",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "Tumor1.Normal1_purity.seg"
                                },
                                {
                                    "name": "#types.yml/FacetsPair/hisens_png",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "..."
                                },
                                {
                                    "name": "#types.yml/FacetsPair/hisens_seg",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "Tumor1.Normal1_hisens.seg"
                                },
                                {
                                    "name": "#types.yml/FacetsPair/qc_txt",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "Tumor1.Normal1.qc.txt"
                                },
                                {
                                    "name": "#types.yml/FacetsPair/gene_level_txt",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "Tumor1.Normal1.gene_level.txt"
                                },
                                {
                                    "name": "#types.yml/FacetsPair/arm_level_txt",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "Tumor2.Normal2.arm_level.txt"
                                },
                                {
                                    "name": "#types.yml/FacetsPair/facets_txt",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "Tumor1.Normal1.txt"
                                },
                                {
                                    "name": "#types.yml/FacetsPair/purity_rds",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "Tumor1.Normal1_purity.rds"
                                },
                                {
                                    "name": "#types.yml/FacetsPair/hisens_rds",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "Tumor1.Normal1_hisens.rds"
                                },
                                {
                                    "name": "#types.yml/FacetsPair/annotated_maf",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "Tumor1.Normal1_hisens.ccf.maf"
                                },
                                {
                                    "name": "#types.yml/FacetsPair/hisens_cncf_txt",
                                    "type": [
                                        "null",
                                        "File"
                                    ],
                                    "doc": "Tumor1.Normal1_hisens.cncf.txt (from legacy facets output)"
                                }
                            ]
                        }
                    ],
                    "id": "#types.yml"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "doc": "genome_coverage value; amount of the genome in bp covered by the assay",
                    "id": "#main/assay_coverage"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "#types.yml/TMBInputPair"
                    },
                    "id": "#main/pairs"
                }
            ],
            "steps": [
                {
                    "scatter": "#main/run_tmb_workflow/pair",
                    "in": [
                        {
                            "source": "#main/assay_coverage",
                            "id": "#main/run_tmb_workflow/assay_coverage"
                        },
                        {
                            "valueFrom": "${ return inputs.pair['pair_maf']; }",
                            "id": "#main/run_tmb_workflow/mutations_file"
                        },
                        {
                            "valueFrom": "${ return inputs.pair['normal_id']; }",
                            "id": "#main/run_tmb_workflow/normal_id"
                        },
                        {
                            "source": "#main/pairs",
                            "id": "#main/run_tmb_workflow/pair"
                        },
                        {
                            "valueFrom": "${ return inputs.pair['pair_id']; }",
                            "id": "#main/run_tmb_workflow/pair_id"
                        },
                        {
                            "valueFrom": "${ return inputs.pair['tumor_id']; }",
                            "id": "#main/run_tmb_workflow/sample_id"
                        }
                    ],
                    "out": [
                        "#main/run_tmb_workflow/pair"
                    ],
                    "run": {
                        "class": "Workflow",
                        "inputs": [
                            {
                                "type": "string",
                                "doc": "genome_coverage value; amount of the genome in bp covered by the assay",
                                "id": "#main/run_tmb_workflow/run/assay_coverage"
                            },
                            {
                                "type": "File",
                                "doc": "File with mutations for the sample",
                                "id": "#main/run_tmb_workflow/run/mutations_file"
                            },
                            {
                                "type": "string",
                                "id": "#main/run_tmb_workflow/run/normal_id"
                            },
                            {
                                "type": "string",
                                "id": "#main/run_tmb_workflow/run/pair_id"
                            },
                            {
                                "type": "string",
                                "id": "#main/run_tmb_workflow/run/sample_id"
                            }
                        ],
                        "outputs": [
                            {
                                "type": "#types.yml/TMBOutputPair",
                                "outputSource": "#main/run_tmb_workflow/run/create_tmb_pair_output/pair",
                                "id": "#main/run_tmb_workflow/run/pair"
                            }
                        ],
                        "steps": [
                            {
                                "doc": "add the sample ID back to the TMB table file",
                                "run": "#paste-col.cwl",
                                "in": [
                                    {
                                        "valueFrom": "${ return \"SampleID\"; }",
                                        "id": "#main/run_tmb_workflow/run/add_sampleID/header"
                                    },
                                    {
                                        "source": "#main/run_tmb_workflow/run/fix_tmb_header/output_file",
                                        "id": "#main/run_tmb_workflow/run/add_sampleID/input_file"
                                    },
                                    {
                                        "valueFrom": "${ return inputs.pair_id + \".tmb.tsv\"; }",
                                        "id": "#main/run_tmb_workflow/run/add_sampleID/output_filename"
                                    },
                                    {
                                        "source": "#main/run_tmb_workflow/run/pair_id",
                                        "id": "#main/run_tmb_workflow/run/add_sampleID/pair_id"
                                    },
                                    {
                                        "source": "#main/run_tmb_workflow/run/sample_id",
                                        "id": "#main/run_tmb_workflow/run/add_sampleID/value"
                                    }
                                ],
                                "out": [
                                    "#main/run_tmb_workflow/run/add_sampleID/output_file"
                                ],
                                "id": "#main/run_tmb_workflow/run/add_sampleID"
                            },
                            {
                                "doc": "calculate the TMB for the variants present based on assay coverage",
                                "run": "#calc-tmb.cwl",
                                "in": [
                                    {
                                        "source": "#main/run_tmb_workflow/run/assay_coverage",
                                        "id": "#main/run_tmb_workflow/run/calc_tmb_value/genome_coverage"
                                    },
                                    {
                                        "source": "#main/run_tmb_workflow/run/muts_maf_filter/cbio_mutation_data_file",
                                        "id": "#main/run_tmb_workflow/run/calc_tmb_value/input_file"
                                    },
                                    {
                                        "source": "#main/run_tmb_workflow/run/normal_id",
                                        "id": "#main/run_tmb_workflow/run/calc_tmb_value/normal_id"
                                    },
                                    {
                                        "valueFrom": "${ return inputs.pair_id + \".tmb.txt\"; }",
                                        "id": "#main/run_tmb_workflow/run/calc_tmb_value/output_filename"
                                    },
                                    {
                                        "source": "#main/run_tmb_workflow/run/pair_id",
                                        "id": "#main/run_tmb_workflow/run/calc_tmb_value/pair_id"
                                    }
                                ],
                                "out": [
                                    "#main/run_tmb_workflow/run/calc_tmb_value/output_file"
                                ],
                                "id": "#main/run_tmb_workflow/run/calc_tmb_value"
                            },
                            {
                                "doc": "gather the TMB analysis outputs into a pair entry",
                                "in": [
                                    {
                                        "source": "#main/run_tmb_workflow/run/normal_id",
                                        "id": "#main/run_tmb_workflow/run/create_tmb_pair_output/normal_id"
                                    },
                                    {
                                        "source": "#main/run_tmb_workflow/run/pair_id",
                                        "id": "#main/run_tmb_workflow/run/create_tmb_pair_output/pair_id"
                                    },
                                    {
                                        "source": "#main/run_tmb_workflow/run/muts_maf_filter/cbio_mutation_data_file",
                                        "id": "#main/run_tmb_workflow/run/create_tmb_pair_output/tmb_maf"
                                    },
                                    {
                                        "source": "#main/run_tmb_workflow/run/add_sampleID/output_file",
                                        "id": "#main/run_tmb_workflow/run/create_tmb_pair_output/tmb_tsv"
                                    },
                                    {
                                        "source": "#main/run_tmb_workflow/run/sample_id",
                                        "id": "#main/run_tmb_workflow/run/create_tmb_pair_output/tumor_id"
                                    }
                                ],
                                "out": [
                                    "#main/run_tmb_workflow/run/create_tmb_pair_output/pair"
                                ],
                                "run": {
                                    "class": "ExpressionTool",
                                    "inputs": [
                                        {
                                            "type": "string",
                                            "id": "#main/run_tmb_workflow/run/create_tmb_pair_output/run/normal_id"
                                        },
                                        {
                                            "type": "string",
                                            "id": "#main/run_tmb_workflow/run/create_tmb_pair_output/run/pair_id"
                                        },
                                        {
                                            "type": "File",
                                            "id": "#main/run_tmb_workflow/run/create_tmb_pair_output/run/tmb_maf"
                                        },
                                        {
                                            "type": "File",
                                            "id": "#main/run_tmb_workflow/run/create_tmb_pair_output/run/tmb_tsv"
                                        },
                                        {
                                            "type": "string",
                                            "id": "#main/run_tmb_workflow/run/create_tmb_pair_output/run/tumor_id"
                                        }
                                    ],
                                    "outputs": [
                                        {
                                            "type": "#types.yml/TMBOutputPair",
                                            "id": "#main/run_tmb_workflow/run/create_tmb_pair_output/run/pair"
                                        }
                                    ],
                                    "expression": "${\n  var pair = {\n    \"pair_id\": inputs.pair_id,\n    \"tumor_id\": inputs.tumor_id,\n    \"normal_id\": inputs.normal_id,\n    \"tmb_maf\": inputs.tmb_maf,\n    \"tmb_tsv\": inputs.tmb_tsv,\n  };\n\n  return {\"pair\": pair};\n}\n"
                                },
                                "id": "#main/run_tmb_workflow/run/create_tmb_pair_output"
                            },
                            {
                                "doc": "turn the TMB value into a table format with header",
                                "run": "#add_header.cwl",
                                "in": [
                                    {
                                        "valueFrom": "${ return \"CMO_TMB_SCORE\"; }",
                                        "id": "#main/run_tmb_workflow/run/fix_tmb_header/header_str"
                                    },
                                    {
                                        "source": "#main/run_tmb_workflow/run/calc_tmb_value/output_file",
                                        "id": "#main/run_tmb_workflow/run/fix_tmb_header/input_file"
                                    }
                                ],
                                "out": [
                                    "#main/run_tmb_workflow/run/fix_tmb_header/output_file"
                                ],
                                "id": "#main/run_tmb_workflow/run/fix_tmb_header"
                            },
                            {
                                "doc": "run the cBioPortal maf filter on the input mutations",
                                "run": "#maf_filter.cwl",
                                "in": [
                                    {
                                        "valueFrom": "${return \"\"; }",
                                        "id": "#main/run_tmb_workflow/run/muts_maf_filter/argos_version_string"
                                    },
                                    {
                                        "valueFrom": "${ return inputs.pair_id + \".tmb.maf\"; }",
                                        "id": "#main/run_tmb_workflow/run/muts_maf_filter/cbio_mutation_data_filename"
                                    },
                                    {
                                        "valueFrom": "${return true; }",
                                        "id": "#main/run_tmb_workflow/run/muts_maf_filter/is_impact"
                                    },
                                    {
                                        "source": "#main/run_tmb_workflow/run/mutations_file",
                                        "id": "#main/run_tmb_workflow/run/muts_maf_filter/maf_file"
                                    },
                                    {
                                        "source": "#main/run_tmb_workflow/run/pair_id",
                                        "id": "#main/run_tmb_workflow/run/muts_maf_filter/pair_id"
                                    }
                                ],
                                "out": [
                                    "#main/run_tmb_workflow/run/muts_maf_filter/cbio_mutation_data_file"
                                ],
                                "id": "#main/run_tmb_workflow/run/muts_maf_filter"
                            }
                        ]
                    },
                    "id": "#main/run_tmb_workflow"
                }
            ],
            "outputs": [
                {
                    "$import": "#main/pairs"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.2"
}
